<?php
session_start(); 
include "includes/header.php";
?>

<body>

    <!-- Header Section Begin -->
    <?php
    include "includes/head.php"
    ?>
    <!-- Header Section End -->

    <!-- Hero Section Begin -->
    <section class="hero hero-normal">
        <div class="container">
            <div class="row">
                <div class="col-lg-3">
                    <?php
                    include "sections/categories.php"
                    ?>
                </div>
                <div class="col-lg-9">
                    <?php
                    include "sections/search.php";
                    ?>
                </div>
            </div>
        </div>
    </section>
    <!-- Hero Section End -->



    <!-- Breadcrumb Section Begin -->
    <section class="">
        <div class="container">
            <div class="row">
                <nav aria-label="breadcrumb">
                    <ol class="breadcrumb">
                        <li class="breadcrumb-item"><a style="color: black !important;" href="./index.php" onmouseover="this.style.color='#225d2d'" onmouseout="this.style.color='black'">Home</a></li>
                        <li class="breadcrumb-item"><a style="color:#1877F2 !important;" href="#"> <b>Delivery Type</b> </a></li>
                    </ol>
                </nav>
            </div>
        </div>
    </section>
    <!-- Breadcrumb Section End -->

    <section style="padding-bottom: 70px; padding-top:8px">
        <div class="container py-2 mb-4" style="background-color: #eee;">
            <p></p>
            <div class="row">
                <div class="col-lg-8 mx-auto text-center mb-4 p-4">
                    <!-- Centered content -->
                    <h5 class="p-4"> <strong>Select delivery type:</strong> </h5>

                    <?php
                    // Check if the form name is "delivery"
                    $formName = isset($_POST['delivery']) ? $_POST['delivery'] : '';

                    if ($formName === 'delivery') {
                        // Retrieve subtotal from POST data
                        $subtotal = isset($_POST['subtotal']) ? $_POST['subtotal'] : 0;

                       echo  '<p> </p>';

                       

                        // Display buttons based on subtotal
                        if ($subtotal >= 500) {
                            // If subtotal is equal or greater than 500, proceed to payment.php
                            echo '<a href="#" onclick="saveSession(\'delivery_type\',1,\'address.php\')" class="btn btn-custom1 m-4">Home/Office Delivery</a>';
                        } else {
                            // If subtotal is less than 500, show a button with a confirmation message
                            echo '<button onclick="showSwal()" class="btn btn-custom1">Home Delivery</button>';
                            echo '<script>
                                    function showSwal() {
                                        Swal.fire({
                                            icon: "warning",
                                            title: "Home Delivery requires a minimum amount of 500",
                                            showCancelButton: false,
                                            showConfirmButton: true,
                                            confirmButtonText: "OK"
                                        });
                                    }
                                  </script>';
                        }
      
                        echo '<a href="#" onclick="saveSession(\'delivery_type\', 2,\'pickup_details.php\')" class="btn btn-custom2 m-4">Store Pickup</a>';

                    } else {
                        // disable the buttons
                        echo '<button class="btn btn-custom1 m-4" disabled>Home Delivery</button>';
                        echo '<button class="btn btn-custom2 m-4" disabled>Store Pickup</button>';
                    }

                    ?>
                </div>
            </div>
        </div>
    </section>

    <?php
    include "includes/footer.php"
    ?>
</body>

<script>
   
   function saveSession(key,value,page) {
        
        $.ajax({
            type: 'POST',
            url: 'functions/set_session.php', 
            data: { key: key,value :value ,page: page},
            success: function(response) {
                window.location.href = page;
            },
            error: function(error) {
               
            }
        });
    }

</script>