<?php
session_start();
require_once '../services/api_config.php';

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $phone = isset($_POST['phone']) ? $_POST['phone'] : '';
    $email = isset($_POST['email']) ? $_POST['email'] : '';
    $name = isset($_POST['name']) ? $_POST['name'] : '';
    $branchid = isset($_POST['branchid']) ? $_POST['branchid'] : '';
    $message = isset($_POST['message']) ? $_POST['message'] : '';


    // Todo => validate user input 

    // Make a POST request to  messages API
    $api_url = API_URL . "messages.php";
    $data = json_encode(['name' => $name, 'email' => $email, 'phone' => $phone, 'message' => $message, 'branchid' => $branchid]);

    $ch = curl_init($api_url);

    // Set  cURL options with the authorization header
    curl_setopt($ch, CURLOPT_HTTPHEADER, [
        'Content-Type: application/json',
        'Auth: ' . API_AUTH_HEADER
    ]);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data);

    // Execute the cURL request
    $response = curl_exec($ch);

    // Check for cURL errors
    if (curl_errno($ch)) {
        // Handle cURL error
        echo "cURL Error: " . curl_error($ch);
    } else {
        // Decode the JSON response
        $result = json_decode($response, true);

        // if ($result['error'] === false) {
        //     $_SESSION['contact_message'] = 'success';
        //     // Redirect to a contact page
        //     // header("Location: ../contact.php");
        //     exit();

        //     $result = json_decode($response, true);

            
        // } else {
        //     // 
        //     $_SESSION['contact_message'] = 'failure';
        //     // header("Location: ../contact.php");
        //     exit();
        // }

        echo json_encode($result);
    }

    // Close cURL session
    curl_close($ch);
}
