<?php

// Include the constants file
require_once './services/api_config.php';

// Function to fetch promotions sales data
function fetchPromotions($branchId) {
    $ch = curl_init(API_URL . "promotions.php?branchid=" . $branchId);

    //  necessary cURL options with the authorization header
    curl_setopt($ch, CURLOPT_HTTPHEADER, [
        'Content-Type: application/json',
        'Auth: ' . API_AUTH_HEADER
    ]);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

    // Execute the cURL request
    $response = curl_exec($ch);

    // Close cURL session
    curl_close($ch);

    // Decode the JSON response
    $promotions = json_decode($response, true);

    // Return the promotions sales data
    return $promotions;
}
?>

