<?php
include "includes/header.php";
if (!isset($_SESSION['user']) || $_SESSION['user']['branchid'] === null || $_SESSION['user']['branchid'] === '' || $_SESSION['user']['branchid'] == 0 || !isset($_SESSION['user_data'])) {
    $_SESSION['login_error_message'] = 'Please login';
    // Redirect to the login page
    echo '<script>window.location.href = "login.php";</script>';
    exit();

    //user is not logged in 
}
$userid =  $_SESSION['user']['ID'];
?>



<body>
    <!-- Page Preloder -->


    <!-- Header Section Begin -->
    <?php
    include "includes/head.php";
    ?>
    <!-- Header Section End -->

    <style>
        #cart-container1 {
            display: none;
        }

        #empty-cart-image {
            display: none;
            text-align: center;
        }

        #goshopping {
            display: none;
            text-align: center;
        }

        #loading-spinner {
            text-align: center;
            padding: 20px;
        }

        #empty-cart-image img {
            max-width: 100%;
            height: auto;
        }
    </style>




    <!-- Hero Section Begin -->
    <section class="hero hero-normal">
        <div class="container">
            <div class="row">
                <div class="col-lg-3">
                    <?php
                    include "sections/categories.php";
                    ?>
                </div>
                <div class="col-lg-9">
                    <?php
                    include "sections/search.php";
                    ?>
                </div>
            </div>
        </div>
    </section>
    <!-- Hero Section End -->

    <!-- Breadcrumb Section Begin -->
    <section class="">
        <div class="container">
            <div class="row">
                <nav aria-label="breadcrumb">
                    <ol class="breadcrumb">
                        <li class="breadcrumb-item"><a style="color: black !important;" href="./index.php" onmouseover="this.style.color='#225d2d'" onmouseout="this.style.color='black'">Home</a></li>
                        <li class="breadcrumb-item"><a style="color:#1877F2 !important;" href="#"> <b>Shopping Cart</b> </a></li>
                    </ol>
                </nav>

            </div>


            <div class="d-flex justify-content-between">
                <h5 class="mb-0"> <b> Cart - <span id="cart-count-badge3" class="cart-count-badge"></span> item(s) </b></h5>

                <button type="button" style="background-color: #225d2d;color:#fff" class="btn remove-item-btn" id="delete-allitems" onclick="deleteItem(0)" data-mdb-toggle="tooltip" title="clear items" disabled>
                    <i class="fa fa-trash"></i> clear cart
                </button>
            </div>


        </div>
    </section>
    <!-- Breadcrumb Section End -->

    <!--  loading spinner -->
    <div id="loading-spinner" style="display: block; text-align: center; padding: 20px;">
        <div class="spinner-border" role="status">
            <span class="visually-hidden"></span>
        </div>

    </div>



    <!-- Container for the empty cart image -->
    <div id="empty-cart-image">
        <img src="./img/empty.png" width="500px" height="550px" alt="Empty Cart" />
    </div>

    <div id="goshopping">
        <button class="btn custom-button1 mb-4 text-white"> <a href="shop-grid.php">Go Shopping</a> </button>

    </div>


    <section id="cart-container1" class="shoping-cart spad">

        <div class="container p-3" style="background-color: #eee;">





            <div class="row d-flex justify-content-center my-2">

                <div id="cart-container" class="col-md-8">


                </div>
                <div class="col-md-4" id="cart-summary">
                    <div class="card mb-4">
                        <div class="card-header py-3">
                            <h5 class="mb-0">Summary</h5>
                        </div>
                        <div class="card-body">
                            <ul class="list-group list-group-flush">
                                <li class="list-group-item d-flex justify-content-between align-items-center border-0 px-0 pb-0">
                                    <strong>Products</strong>
                                    <span id='productscount'></span>
                                </li>
                                <li class="list-group-item d-flex justify-content-between align-items-center px-0">
                                    <strong>Subtotal</strong>
                                    <span></span>
                                </li>
                                <li class="list-group-item d-flex justify-content-between align-items-center border-0 px-0 mb-3">
                                    <div>
                                        <strong>Total amount</strong>
                                        <strong>
                                            <p class="mb-0">(including VAT)</p>
                                        </strong>
                                    </div>
                                    <span><strong></strong></span>
                                </li>
                            </ul>



                            <form action="delivery.php" method="post">
                                <input type="hidden" id="subtotal-input" name="subtotal">
                                <input type="hidden" name="delivery" value="delivery">
                                <button type="submit" class="btn btn-primary btn-lg btn-block custom-button1">
                                    Go to checkout
                                </button>
                            </form>

                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>

    <!-- Footer Section Begin -->
    <?php
    include "includes/footer.php";
    ?>
    <!-- Footer Section End -->

    <script>
        $(document).ready(function() {

            // Call the fetchCartData function on page load
            fetchCartData();

        });






        //fetch data
        function fetchCartData() {

            var fetchCartUrl = 'functions/fetchcart.php?userid=<?php echo $userid; ?>&branchid=<?php echo $branchid; ?>';

            $.ajax({
                type: 'GET',
                url: fetchCartUrl,
                dataType: 'json',
                success: function(data) {

                    // Update the cart items on success
                    if (data.length > 0) {
                        // If the cart is not empty, update the cart items
                        updateCartItems(data);
                        updateCartSummary(data);
                        // Hide the loading spinner and show the cart container
                        $('#loading-spinner').hide();
                        $('#cart-container1').show();
                        $('#delete-allitems').prop('disabled', false);
                    } else {
                        // If the cart is empty, hide the cart container and show the empty cart image
                        $('#loading-spinner').hide();
                        $('#cart-container1').hide();
                        $('#empty-cart-image').show();
                        $('#goshopping').show();
                        $('#delete-allitems').prop('disabled', true);
                    }


                },
                error: function(error) {
                    console.log('Error fetching cart:', error);
                }
            });
        }

        // Function to update quantity using Ajax
        function updateQuantity(itemId, quantityChange) {
            var quantityInput = $(`#quantity-${itemId}`);
            var decrementButton = $(`#decrement-${itemId}`);
            var incrementButton = $(`#increment-${itemId}`);
            var newQuantity = parseInt(quantityInput.val()) + quantityChange;

            if (newQuantity >= 1) {
                var availableQuantity = parseInt(quantityInput.attr('max'));

                if (newQuantity <= availableQuantity) {
                    // Disable the buttons while processing
                    quantityInput.prop('disabled', true);
                    decrementButton.prop('disabled', true);
                    incrementButton.prop('disabled', true);

                    // Add a spinner to the buttons
                    decrementButton.html('<i class="fa fa-spinner fa-spin"></i>');
                    incrementButton.html('<i class="fa fa-spinner fa-spin"></i>');

                    // Perform Ajax request to update quantity on the server
                    $.ajax({
                        type: 'POST',
                        url: 'functions/updatecart.php',
                        data: {
                            itemId: itemId,
                            quantityChange: newQuantity
                        },
                        success: function(response) {
                            var jsonResponse = JSON.parse(response);

                            if (jsonResponse.success === true) {
                                toastr.success('Cart updated successfully.');
                            } else {
                                toastr.error('Failed to update cart:', {
                                    timeOut: 5000
                                });
                            }

                            // Enable the buttons and remove the spinner
                            quantityInput.prop('disabled', false);
                            decrementButton.prop('disabled', false);
                            incrementButton.prop('disabled', false);
                            decrementButton.html('<i class="fa fa-minus"></i>');
                            incrementButton.html('<i class="fa fa-plus"></i>');

                            fetchCartData();
                            getCartCount();
                        },
                        error: function(error) {
                            console.log('Error updating quantity:', error);

                            // Enable the buttons and remove the spinner on error
                            quantityInput.prop('disabled', false);
                            decrementButton.prop('disabled', false);
                            incrementButton.prop('disabled', false);
                            decrementButton.html('<i class="fa fa-minus"></i>');
                            incrementButton.html('<i class="fa fa-plus"></i>');
                        }
                    });
                } else {
                    // Display an error message
                    toastr.error(`Failed to update cart: You cannot add more than ${availableQuantity} quantity of this item.`);
                }
            }
        }


        // Function to delete an item using Ajax
        function deleteItem(itemId) {
            if (itemId == '0') {
                var deleteButton = $(`#delete-allitems`);
                var message = "cart cleared successfully";
                var failure = "failed to clear items"
            } else {
                var deleteButton = $(`#delete-${itemId}`);
                var message = "item deleted successfully";
                var failure = "failed to delete item"
            }

            deleteButton.prop('disabled', true);

            deleteButton.html('<i class="fa fa-spinner fa-spin"></i>');

            // Make an AJAX request to deletecart.php
            $.ajax({
                type: 'GET',
                url: 'functions/deletecart.php?id=' + itemId,
                success: function(response) {


                    var jsonResponse = JSON.parse(response);

                    if (jsonResponse.success === true) {
                        fetchCartData();
                        getCartCount();
                        toastr.success(message);
                    } else {
                        toastr.error(failure, {
                            timeOut: 5000
                        });
                    }

                    if (itemId == '0') {

                        deleteButton.html('clear items <i class="fa fa-trash"></i>');
                    } else {

                        deleteButton.html('<i class="fa fa-trash"></i>');
                    }



                },
                error: function(xhr, status, error) {
                    console.error("AJAX Error: " + error);
                }
            });
        }


        function updateCartItems(cartItems) {
            var cartContainer = $('#cart-container');
            cartContainer.empty();

            // cartContainer.html('Loading<i class="fa fa-spinner fa-spin"></i>');

            // Loop through each item in the cart and append it to the container
            $.each(cartItems, function(index, cartItem) {
                var cartItemHtml = `
    <div class="card mb-4">
        <div class="card-body">
            <div class="row">
                <div class="col-lg-3 col-md-12 mb-4 mb-lg-0">
                    <div class="bg-image hover-overlay hover-zoom ripple rounded" data-mdb-ripple-color="light">
                        <img src="${cartItem.image ? cartItem.image : 'img/noimage.png'}" class="w-100" alt="image" width="100" loading="lazy" />
                        <a href="#!">
                            <div class="mask" style="background-color: rgba(251, 251, 251, 0.2)"></div>
                        </a>
                    </div>
                </div>

                <div class="col-lg-5 col-md-6 mb-lg-0">
                    <p><strong>${cartItem.name}</strong></p>
                    <p><strong>KSh. ${Number(cartItem.price).toLocaleString('en-US', { minimumFractionDigits: 2, maximumFractionDigits: 2 })}</strong></p>
                    ${cartItem.quantity > cartItem.availablequantity
                                    ? `

                                    <s>  <p>KSh. ${Number(cartItem.price).toLocaleString('en-US', { minimumFractionDigits: 2, maximumFractionDigits: 2 })} * ${cartItem.quantity} = KSh. ${Number(cartItem.totalprice).toLocaleString('en-US', { minimumFractionDigits: 2, maximumFractionDigits: 2 })}</p>  </s>
                                    <small style="color:red">Remaining ${cartItem.availablequantity} </small>

                                    <p>KSh. ${Number(cartItem.price).toLocaleString('en-US', { minimumFractionDigits: 2, maximumFractionDigits: 2 })} * ${cartItem.availablequantity} = KSh. ${Number(cartItem.price * cartItem.availablequantity).toLocaleString('en-US', { minimumFractionDigits: 2, maximumFractionDigits: 2 })}</p>

                    `
                                    : `
                    <p>KSh. ${Number(cartItem.price).toLocaleString('en-US', { minimumFractionDigits: 2, maximumFractionDigits: 2 })} * ${cartItem.quantity} = KSh. ${Number(cartItem.totalprice).toLocaleString('en-US', { minimumFractionDigits: 2, maximumFractionDigits: 2 })}</p>

                    `}
                    <div class="d-flex flex-column pt-3" style="max-width: 300px; align-items: flex-end;">
                        <div class="d-flex mb-2">
                            ${cartItem.availablequantity < 1
                                ? '<button class="btn btn-md px-3 custom-button3">Sold Out</button>'
                                : `
                                ${cartItem.quantity > cartItem.availablequantity
                                    ? `
                                                         
                                    <button class="btn mr-2 px-3 me-2 custom-button" id="decrement-${cartItem.id}" onclick="updateQuantity(${cartItem.id}, -1)">
                                        <i class="fa fa-minus"></i>
                                    </button>
                                    
                                    <input id="quantity-${cartItem.id}" min="1" max="${cartItem.availablequantity}" name="quantity" value="${cartItem.availablequantity}" type="number" class="form-control" disabled/>
                                    
                                    <button class="btn ml-2 px-3 ms-2 custom-button" id="increment-${cartItem.id}" onclick="updateQuantity(${cartItem.id}, 1)">
                                        <i class="fa fa-plus"></i>
                                    </button>
                                      
                                    `
                                    : `
                                    <button class="btn mr-2 px-3 me-2 custom-button" id="decrement-${cartItem.id}" onclick="updateQuantity(${cartItem.id}, -1)">
                                        <i class="fa fa-minus"></i>
                                    </button>
                                    
                                    <input id="quantity-${cartItem.id}" min="1" max="${cartItem.availablequantity}" name="quantity" value="${cartItem.quantity}" type="number" class="form-control" disabled/>
                                    
                                    <button class="btn ml-2 px-3 ms-2 custom-button" id="increment-${cartItem.id}" onclick="updateQuantity(${cartItem.id}, 1)">
                                        <i class="fa fa-plus"></i>
                                    </button>
                                `}
                                `
                            }
                        </div>
                    </div>
                   
                </div>

                <div class="col-lg-4 col-md-6 mb-4 mb-lg-0">
                    <div class="d-flex justify-content-between">
                        <div></div>
                        <div class="d-flex justify-content-center">
                            <button type="button" class="btn btn-danger btn-sm remove-item-btn" id="delete-${cartItem.id}"  onclick="deleteItem(${cartItem.id})" data-mdb-toggle="tooltip" title="Remove item">
                                <i class="fa fa-trash"></i>
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
`;


                cartContainer.append(cartItemHtml);
            });
        }

        // Function to update cart summary using Ajax
        function updateCartSummary(cartItems) {
            var productsTotal = 0;


            // Calculate the total price of products
            $.each(cartItems, function(index, cartItem) {
                // Use cartItem.availablequantity if it's less than cartItem.quantity
                var quantityToUse = Math.min(cartItem.quantity, cartItem.availablequantity);
                productsTotal += cartItem.price * quantityToUse;
            });

            // Update the cart summary

            $('.list-group-item:eq(1) span').text("KSh. " + productsTotal.toLocaleString('en-US', {
                minimumFractionDigits: 2,
                maximumFractionDigits: 2
            }));
            $('.list-group-item:eq(2) span strong').text("KSh. " + productsTotal.toLocaleString('en-US', {
                minimumFractionDigits: 2,
                maximumFractionDigits: 2
            }));

            $('#subtotal-input').val(productsTotal);

            // If the cart is empty, you may want to hide the summary section
            if (cartItems.length === 0) {
                $('#cart-summary').hide();
            } else {
                $('#cart-summary').show();
            }
        }
    </script>