<?php
session_start();
include "includes/header.php";
$phone = $_SESSION['user']['Number'];
if (isset($_POST['payment'])) {
    $buttonDisabled = false;
    // Retrieve data from the form
    $subTotal = isset($_POST['subtotal']) ? $_POST['subtotal'] : null;
    $deliveryType = isset($_POST['delivery']) ? $_POST['delivery'] : null;
    $paidamount = isset($_POST['amount']) ? $_POST['amount'] : null;
} else {
    $buttonDisabled = true;
}
?>

<style>
    .btn-success {
        background-color: #225d2d !important;
        color: #fff !important;
    }
</style>

<!-- Header Section Begin -->
<?php include "includes/head.php"; ?>
<!-- Hero Section Begin -->
<section class="hero hero-normal">
    <div class="container">
        <div class="row">
            <div class="col-lg-3">
                <?php include "sections/categories.php"; ?>
            </div>
            <div class="col-lg-9">
                <?php include "sections/search.php"; ?>
            </div>
        </div>
    </div>
</section>
<!-- Hero Section End -->

<!-- Breadcrumb Section Begin -->
<section class="">
    <div class="container">
        <div class="row">
            <nav aria-label="breadcrumb">
                <ol class="breadcrumb">
                    <li class="breadcrumb-item"><a style="color: black !important;" href="./index.php" onmouseover="this.style.color='#225d2d'" onmouseout="this.style.color='black'">Home</a></li>
                    <li class="breadcrumb-item"><a style="color:#1877F2 !important;" href="#"> <b>Payment</b> </a></li>
                </ol>
            </nav>
        </div>
    </div>
</section>
<!-- Breadcrumb Section End -->



<section style="padding-bottom: 70px; padding-top:8px">
    <div class="container py-2 mb-4" style="background-color: #eee;">
        <p></p>
        <div class="row">
            <div class="col-lg-8 mx-auto text-center mb-4 p-4">
                <div id="dialogue" style="display: none;">
                    <div class="spinner-border mb-2" role="status">
                        <span class="sr-only"></span>
                    </div>
                    <p id="message_status">Please wait,processing payment</p>
                </div>

                <div class="card p-2 text-center">

                    <img src="./img/mpesa2.png" width="100px" height="100px" style="margin-left: auto; margin-right:auto" alt="">
                    <div class="form-check p-2" style="font-size:larger">
                        <input class="form-check-input" type="checkbox" value="<?php $phone ?>" id="useMyNumber" checked>
                        use my number <?php $phone ?>
                    </div>
                    <div class="form-check" style="font-size:larger">
                        <input class="form-check-input" type="checkbox" value="" id="enterNewNumber">
                        <label class="form-check-label" for="enterNewNumber">
                            Enter new number
                        </label>
                    </div>
                    <div id="newNumberInput" style="display: none;">
                        <input type="text" id="newNumber" class="form-control" placeholder="Enter new number">
                    </div>
                </div>

                <form id="paymentForm">
                    <input type="hidden" name="url" id="url">
                    <input type="hidden" name="paidamount" id="paidamount" value="<?php echo $paidamount ?>">



                    <button type="submit" id="submit_button" class="btn btn-success btn-lg mt-3" <?php echo $buttonDisabled ? 'disabled' : ''; ?>>
                        Confirm and Pay
                    </button>

                </form>
       </div>
        </div>
    </div>
</section>

<?php include "includes/footer.php"; ?>

<script>
    $(document).ready(function() {
        // disableButton();
        getShortcode();


        var useMyNumberCheckbox = $('#useMyNumber');
        var enterNewNumberCheckbox = $('#enterNewNumber');
        var newNumberInput = $('#newNumberInput');
        var newNumberField = $('#newNumber');

        useMyNumberCheckbox.change(function() {
            if (useMyNumberCheckbox.is(':checked')) {
                enterNewNumberCheckbox.prop('checked', false);
                newNumberInput.hide();
            }
        });

        enterNewNumberCheckbox.change(function() {
            if (enterNewNumberCheckbox.is(':checked')) {
                useMyNumberCheckbox.prop('checked', false);
                newNumberInput.show();
            } else {
                newNumberInput.hide();
            }
        });

        $('#paymentForm').submit(function(event) {
            event.preventDefault();

            var phonenumber = useMyNumberCheckbox.is(':checked') ? "<?php echo $phone; ?>" : newNumberField.val();
            var url = $('#url').val();
            var paidamount = $('#paidamount').val();
            var ordernumber = "Kassmatt E-commerce Order payment"
            var dialogue = document.getElementById('dialogue');

            // Hide the dialogue
            dialogue.style.display = 'block';

            // Call the stkpush function with the data
            // stkpush(url, phonenumber, ordernumber, paidamount);
            // poststk(url,phonenumber,ordernumber,1)


        });

    });

    function getShortcode() {
        $.ajax({
            type: 'GET',
            url: 'functions/getShortcode.php',
            dataType: 'json',
            success: function(response) {
                var url = response.url;
                $('#url').val(url);
                // enableButton();
            },
            error: function(error) {
                console.log('Error short code:', error);
            }
        });
    }



    function showErrorAlert(message) {
        Swal.fire({
            title: 'Error',
            text: message,
            icon: 'error',
        })

    }



    function postTransaction(urlWebService, merchantRequestID, checkoutRequestID) {
        // Implement the postTransaction logic here
        // Similar to the checkpayment function
    }

    function showErrorAlert(message) {
        // Implement your error alert logic here
        alert('Error: ' + message);
    }


    function stkpush(url, phonenumber, ordernumber, paidamount) {
        // Disable the button or perform any other necessary actions
        disableButton();
        // showDialogue("processing payment...don't close this page")

        var dialogue = document.getElementById('dialogue');

        // Hide the dialogue
        dialogue.style.display = 'block';

        // Make an AJAX request to the server
        $.ajax({
            type: 'GET',
            url: 'functions/payment.php',
            data: {
                phonenumber: phonenumber,
                ordernumber: ordernumber,
                paidamount: paidamount,
                url: url
            },
            dataType: 'json',
            success: function(response) {
                // Handle the response as needed

                console.log("response is", response);

                if (response.ResponseCode === '0') {
                    var merchantRequestID = response.MerchantRequestID;
                    var checkoutRequestID = response.CheckoutRequestID;

                    // Save data in localStorage
                    // localStorage.setItem('MerchantRequestID', merchantRequestID);
                    // localStorage.setItem('CheckoutRequestID', checkoutRequestID);

                    console.log("merchantRequestID", merchantRequestID);
                    console.log("checkoutRequestID", checkoutRequestID)

                    // Retrieve data from localStorage
                    // var merchantRequestIDx = localStorage.getItem('MerchantRequestID');
                    // var checkoutRequestIDx = localStorage.getItem('CheckoutRequestID');

                    // Call checkpayment function
                    checkpayment(merchantRequestID, checkoutRequestID);

                    // Make a call to checkpayment
                    // checkpayment('https://kassmatt.com/kassmattv2/rms_server/api/insert_payment.php',
                    // merchantRequestID,
                    // checkoutRequestID
                    // );

                    // Clear the data from localStorage
                    // localStorage.removeItem('MerchantRequestID');
                    // localStorage.removeItem('CheckoutRequestID');


                } else {
                    Swal.fire({
                        title: 'Error',
                        text: 'Payment request failed,Please try again.',
                        icon: 'error',
                    }).then((result) => {
                        // Enable the button or perform any other necessary actions
                        // enableButton();
                    });
                }


            },
            error: function() {

                Swal.fire({
                    title: 'Error',
                    text: 'Payment request failed,Please try again.',
                    icon: 'error',
                }).then((result) => {

                });
            }

        });

        hideDialogue();
    }


    function checkpayment(merchantRequestIDx, checkoutRequestIDx) {

        showDialogue("please wait,processing payment...");
        $.ajax({
            type: 'POST',
            url: 'functions/insert_payment.php',
            data: {
                merchantRequestID: merchantRequestIDx,
                checkoutRequestID: checkoutRequestIDx,
            },
            dataType: 'json',
            success: function(response) {
                // Handle the response as needed
                console.log("insert_payment response is", response);

                if (response.success) {
                    // Payment data inserted successfully

                    console.log("success", response.message)

                    toastr.success(response.message);

                    // Make a call to postTransaction
                    // postTransaction('https://kassmatt.com/kassmattv2/rms_server/api/postOders.php',
                    //     merchantRequestID,
                    //     checkoutRequestID
                    // );

                } else {
                    // Failed to insert payment data or error occurred

                    console.log("error", response.message)
                    toastr.error(response.message);
                }

            },
            error: function(jqXHR, textStatus, errorThrown) {

                Swal.fire({
                    title: 'Error',
                    text: 'Payment request failed. Please try again.',
                    icon: 'error',
                }).then((result) => {
                    // Handle the error as needed
                });
            }
        });

        hideDialogue();
    }




    // Function to show the dialogue and change message status
    function showDialogue(message) {
        // var dialogue = document.getElementById('dialogue');
        // var messageStatus = document.getElementById('message_status');

        // // Set the message
        // messageStatus.innerText = message;

        // // Show the dialogue
        // dialogue.style.display = 'block';
    }

    // Function to hide the dialogue
    function hideDialogue() {
        // var dialogue = document.getElementById('dialogue');

        // // Hide the dialogue
        // dialogue.style.display = 'none';
    }

    function disableButton() {
        // Disable the button
        // var submitBtn = document.getElementById("submit_button");
        // submitBtn.text("loading...")
        // submitBtn.disabled = true;

    }

    function enableButton() {
        // var submitBtn = document.getElementById("submit_button");
        // submitBtn.text("CONFIRM AND PAY")
        // submitBtn.disabled = true;
    }
</script>