<?php
include "includes/header.php";

if (!isset($_SESSION['user']) || $_SESSION['user']['branchid'] === null || $_SESSION['user']['branchid'] === '' || $_SESSION['user']['branchid'] == 0 || !isset($_SESSION['user_data'])) {
    $_SESSION['login_error_message'] = 'Please login';
    // Redirect to the login page
    echo '<script>window.location.href = "login.php";</script>';
    exit();

    //user is not logged in 
}
?>

<body>
    <!-- Page Preloder -->
    <div id="preloder">
        <div class="loader"></div>
    </div>

    <!-- Header Section Begin -->
    <?php
    include "includes/head.php";

    $userdata = $_SESSION['user_data'];

    ?>
    <!-- Header Section End -->







    <!-- Hero Section Begin -->
    <section class="hero hero-normal">
        <div class="container">
            <div class="row">
                <div class="col-lg-3">
                    <?php
                    include "sections/categories.php"
                    ?>
                </div>
                <div class="col-lg-9">
                    <?php
                    include "sections/search.php";
                    ?>
                </div>
            </div>
        </div>
    </section>
    <!-- Hero Section End -->

    <!-- Breadcrumb Section Begin -->
    <section class="">
        <div class="container">
            <div class="row">
                <nav aria-label="breadcrumb">
                    <ol class="breadcrumb">
                        <li class="breadcrumb-item"><a style="color: black !important;" href="./index.php" onmouseover="this.style.color='#225d2d'" onmouseout="this.style.color='black'">Home</a></li>

                        <li class="breadcrumb-item"><a style="color:#1877F2 !important;" href="#"> <b>Profile</b> </a></li>
                    </ol>
                </nav>
            </div>
        </div>
    </section>
    <!-- Breadcrumb Section End -->

    <section style="padding-bottom: 70px; padding-top:8px">
        <div class="container py-2 mb-4" style="background-color: #eee;">
            <p>You can edit Details and click update</p>
            <div class="row">
                <div class="col-lg-4">
                    <div class="card mb-4">
                        <div class="card-body text-center">
                            <img src="./img/user.png" alt="avatar" class="rounded-circle img-fluid" style="width: 150px;">
                            <h5 class="my-3"><?php echo $userdata['Fullname']; ?></h5>
                            <p class="text-muted mb-1"><?php echo $userdata['Mobile']; ?></p>
                            <p class="text-muted mb-4"><?php echo $userdata['EmailAdd']; ?></p>
                            <div class="d-flex justify-content-center mb-2">


                                <?php if ($branch_needed == 1) : ?>
                                    <p style="color: #225d2d;"> <b><?php echo $userdata['branch']; ?></b> </p>

                                <?php endif; ?>
                            </div>
                        </div>
                    </div>

                </div>
                <div class="col-lg-8">
                    <form>
                        <div class="card mb-4">
                            <div class="card-body">
                                <div class="row">
                                    <div class="col-sm-3">
                                        <p class="mb-0">Full Name</p>
                                    </div>
                                    <div class="col-sm-9">

                                        <input type="text" name="name" value="<?php echo $userdata['Fullname']; ?>" required>
                                    </div>
                                </div>
                                <hr>
                                <div class="row">
                                    <div class="col-sm-3">
                                        <p class="mb-0">Email</p>
                                    </div>
                                    <div class="col-sm-9">
                                        <input type="text" name="email" value="<?php echo $userdata['EmailAdd']; ?>" required>
                                    </div>
                                </div>
                                <hr>
                                <div class="row">
                                    <div class="col-sm-3">
                                        <p class="mb-0">Phone</p>
                                    </div>
                                    <div class="col-sm-9">
                                        <input type="text" name="cell" value="<?php echo $userdata['Mobile']; ?>" disabled>
                                    </div>
                                </div>
                                <hr>
                                <div class="row">
                                    <div class="col-sm-3">
                                        <p class="mb-0">Physical Address</p>
                                    </div>
                                    <div class="col-sm-9">
                                        <input type="text" name="Physicaladdress" value="<?php echo $userdata['Physicaladdress']; ?>" required>

                                    </div>
                                </div>
                                <hr>
                                <div class="row">
                                    <div class="col-sm-3">
                                        <p class="mb-0">Postal Address</p>
                                    </div>
                                    <div class="col-sm-9">

                                        <input type="text" name="Postaladdress" value="<?php echo $userdata['Postaladdress']; ?>" required>

                                    </div>
                                </div>
                                <hr>
                                <div class="row">
                                    <div class="col-sm-3">
                                        <p class="mb-0">Town</p>
                                    </div>
                                    <div class="col-sm-9">

                                        <input type="text" name="town" value="<?php echo $userdata['Town']; ?>" required>

                                    </div>
                                </div>
                                <hr>
                                <div class="row">
                                    <div class="col-sm-3">
                                        <p class="mb-0">ID Number</p>
                                    </div>
                                    <div class="col-sm-9">

                                        <input type="text" name="idnumber" value="<?php echo $userdata['Idnumber']; ?>" required>

                                    </div>
                                </div>
                                <hr>
                                <div class="row">
                                    <div class="col-sm-3">
                                        <p class="mb-0">Gender</p>
                                    </div>

                                   
                                    <div class="col-sm-9">
                                        <select class="form-select" name="gender" required>
                                            <option value="" <?php echo (empty($userdata['Gender']) || $userdata['Gender'] === null) ? 'selected' : ''; ?>>SELECT GENDER</option>
                                            <option value="1" <?php echo ($userdata['Gender'] === 1 && !empty($userdata['Gender'])) ? 'selected' : ''; ?>>Male</option>
                                            <option value="2" <?php echo ($userdata['Gender'] === 2 && !empty($userdata['Gender'])) ? 'selected' : ''; ?>>Female</option>
                                            <option value="3" <?php echo (!empty($userdata['Gender']) && !in_array($userdata['Gender'], [1, 2])) ? 'selected' : ''; ?>>Other</option>
                                        </select>
                                    </div>




                                </div>
                                <hr>
                                <div class="row">
                                    <div class="col-sm-3">
                                        <p class="mb-0">Birthday</p>
                                    </div>
                                    <div class="col-sm-9">
                                        <input type="date" name="dob" value="<?php echo $userdata['DateofBirth']; ?>" required>

                                    </div>
                                </div>
                            </div>
                        </div>

                        <input type="hidden" name="id" value="<?php echo $userdata['id']; ?>">
                        <input type="hidden" name="mobile" value="<?php echo $userdata['Mobile']; ?>">



                        <div class="d-flex justify-content-end">
                            <button type="submit" id="submitBtn" class="btn btn-main"> <i class="fa fa-edit"></i> UPDATE</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </section>

    <?php
    include "includes/footer.php"
    ?>

    <script>
        function disableButton() {

            // Disable the button
            var submitBtn = document.getElementById("submitBtn");
            submitBtn.disabled = true;
            // Change background color to gray
            submitBtn.classList.add('btn-load');
            // Change the button text
            submitBtn.innerHTML = 'Processing...';


        }

        function enableButton() {
            // enable the button
            var submitBtn = document.getElementById("submitBtn");
            submitBtn.disabled = false;
            // Change background color to gray
            submitBtn.classList.remove('btn-load');
            submitBtn.classList.add('btn-main');
            // Change the button text
            submitBtn.innerHTML = 'UPDATE';
        }

        $(document).ready(function() {



            // Submit the form using jQuery
            $('form').submit(function(event) {
                event.preventDefault();


                // Get form data
                var formData = $(this).serialize();

                disableButton();

                // Make an AJAX request to the server
                $.ajax({
                    type: 'POST',
                    url: 'functions/update_profile.php',
                    data: formData,
                    dataType: 'json',
                    success: function(response) {
                        // Show SweetAlert based on the response
                        if (response.success) {


                            var mobile = <?php echo json_encode($userdata['Mobile']); ?>;

                            getUpdatedData(mobile);


                        } else {
                            Swal.fire({
                                title: 'Error',
                                text: response.message,
                                icon: 'error',
                            }).then((result) => {
                                enableButton()

                            });
                        }
                    },
                    error: function() {
                        Swal.fire({
                            title: 'Error',
                            text: 'An error occurred while processing your request.Please try again',
                            icon: 'error',
                        }).then((result) => {
                            enableButton()

                        });
                    }
                });


            });
        });

        function getUpdatedData(mobile) {
            //pass mobile as formdata
            var formData = {
                mobile: mobile,
            };

            $.ajax({
                type: 'POST',
                url: 'functions/profile.php',
                data: formData,
                dataType: 'json',
                success: function(response) {
                    // Show SweetAlert based on the response
                    Swal.fire({
                        title: 'Success',
                        text: 'Profile updated successfully!!',
                        icon: 'success',
                    })
                },
                error: function() {
                    Swal.fire({
                        title: 'Error',
                        text: 'An error occurred while processing your request. Please try again',
                        icon: 'error',
                    }).then((result) => {
                        enableButton();
                    });
                },
                complete: function() {
                    enableButton();
                }
            });
        }
    </script>