<?php include "includes/header.php" ?>

<style>
    .password-toggle {
        position: absolute;
        right: 10px;
        top: 50%;
        transform: translateY(-50%);
        cursor: pointer;
    }
</style>


<body>


    <section class="d-flex justify-content-center align-items-center">
        <div class="container">
            <div class="row justify-content-center align-items-center">
                <div class="col-12 col-lg-9 col-xl-7">
                    <div class="card  card-bg mt-3">

                        <div class="card-body  text-center">

                            <!-- <img src="./img/logo2.jpg" class="rounded-circle " alt="Profile Image" style="width: 130px; height: 130px;"> -->

                            <img src="./img/logo2.jpg" class="mb-0" alt="Profile Image" width="180">
                            <!-- <h3 class="fw-bold mb-4 text-uppercase">Kassmatt Supermarket</h3> -->
                            <h3 class="mb-4">Sign Up</h3>

                            <form>
                                <div class="row">
                                    <div class="col-md-12 mb-2">
                                        <div class="form-outline">
                                            <input type="text" name="fullname" id="fullname" class="form-control form-control-lg" required />
                                            <label class="form-label" for="fullname">Full Name</label>
                                        </div>
                                    </div>

                                </div>
                                <div class="row">
                                    <div class="col-md-6 mb-2">

                                        <div class="form-outline">
                                            <input type="text" name="cell" id="firstName" class="form-control form-control-lg" required />
                                            <label class="form-label" for="firstName">Mobile Number</label>
                                        </div>

                                    </div>
                                    <div class="col-md-6 mb-2">

                                        <div class="form-outline">
                                            <input type="email" id="email" name="email" class="form-control form-control-lg" required />
                                            <label class="form-label" for="email">Email</label>
                                        </div>

                                    </div>

                                </div>
                                <div class="row">
                                    <div class="col-md-6 mb-2">

                                        <div class="form-outline">

                                            <div class="input-group">
                                                <input type="password" name="password" id="password" class="form-control form-control-lg" required />
                                                <button class="btn btn-outline-secondary" type="button" id="password-toggle">
                                                    <i id="icon-eye" class="fa fa-eye"></i>
                                                </button>
                                            </div>

                                            <label class="form-label" for="password">Password</label>
                                        </div>

                                    </div>
                                    <div class="col-md-6 mb-2">

                                        <div class="form-outline">
                                            <div class="input-group">
                                                <input type="password" name="confirm_password" id="confirm_password" class="form-control form-control-lg" required />
                                                <button class="btn btn-outline-secondary" type="button" id="password-toggle2">
                                                    <i id="icon-eye2" class="fa fa-eye"></i>
                                                </button>
                                            </div>
                                            <label class="form-label" for="confirm_password">Confirm Password</label>
                                        </div>


                                    </div>


                                </div>
                                <button class="btn btn-lg btn-main" id="submitBtn" type="submit">REGISTER</button>

                                <div>
                                    <p class="mb-0 mt-2">Already have Account? Login here
                                        <a href="login.php" class="link text-dark-50 fw-bold">Sign In</a>
                                    </p>
                                </div>



                            </form>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>



    <!--  jQuery -->
    <script src="https://code.jquery.com/jquery-3.6.4.min.js"></script>

    <!--  SweetAlert library -->
    <script src="https://cdn.jsdelivr.net/npm/sweetalert2@11"></script>


    <script>
        document.getElementById('password-toggle').addEventListener('click', function() {
            const passwordInput = document.getElementById('password');
            const eyeIcon = document.getElementById('icon-eye');


            if (passwordInput.type === 'password') {
                passwordInput.type = 'text';
                eyeIcon.classList.remove('bi-eye');
                eyeIcon.classList.add('bi-eye-slash');
            } else {
                passwordInput.type = 'password';
                eyeIcon.classList.remove('bi-eye-slash');
                eyeIcon.classList.add('bi-eye');
            }


        });

        document.getElementById('password-toggle2').addEventListener('click', function() {


            const eyeIcon2 = document.getElementById('icon-eye2')

            const passwordInput_confirmation = document.getElementById('confirm_password');;


            if (passwordInput_confirmation.type === 'password') {
                passwordInput_confirmation.type = 'text';
                eyeIcon2.classList.remove('bi-eye');
                eyeIcon2.classList.add('bi-eye-slash');
            } else {
                passwordInput_confirmation.type = 'password';
                eyeIcon2.classList.remove('bi-eye-slash');
                eyeIcon2.classList.add('bi-eye');
            }
        });
    </script>

    <script>
        function disableButton() {

            // Disable the button
            var submitBtn = document.getElementById("submitBtn");
            submitBtn.disabled = true;
            // Change background color to gray
            submitBtn.classList.add('btn-load');
            // Change the button text
            submitBtn.innerHTML = 'REGISTER';


        }

        function enableButton() {
            // enable the button
            var submitBtn = document.getElementById("submitBtn");
            submitBtn.disabled = false;
            // Change background color to gray
            submitBtn.classList.remove('btn-load');
            submitBtn.classList.add('btn-main');
            // Change the button text
            submitBtn.innerHTML = 'REGISTER';
        }
    </script>


    <script>
        $(document).ready(function() {

            // Submit the form using jQuery
            $('form').submit(function(event) {
                event.preventDefault(); // Prevent the default form submission
                disableButton();

                // Check if passwords match
                var password = $('#password').val();
                var confirmPassword = $('#confirm_password').val();

                if (password !== confirmPassword) {
                    Swal.fire({
                        title: 'Error',
                        text: 'Passwords do not match.',
                        icon: 'error',
                    }).then((result) => {
                        // enable button
                        enableButton();
                    });;
                    return;


                }

                // Get form data
                var formData = $(this).serialize();

                disableButton();

                // Make an AJAX request to the server
                $.ajax({
                    type: 'POST',
                    url: 'functions/register.php',
                    data: formData,
                    dataType: 'json',
                    success: function(response) {
                        // Show SweetAlert based on the response
                        if (response.success) {
                            Swal.fire({
                                title: 'Success',
                                text: response.message,
                                icon: 'success',
                            }).then((result) => {
                                enableButton()
                                // Redirect to login page 
                                window.location.href = 'login.php';
                            });
                        } else {
                            Swal.fire({
                                title: 'Error',
                                text: response.message,
                                icon: 'error',
                            }).then((result) => {
                                enableButton()

                            });
                        }
                    },
                    error: function() {
                        Swal.fire({
                            title: 'Error',
                            text: 'An error occurred while processing your request.Please try again',
                            icon: 'error',
                        }).then((result) => {
                            enableButton()

                        });
                    }
                });


            });
        });
    </script>




</body>

</html>