<?php
include "includes/header.php";
?>

<body>
    <!-- Page Preloder -->
    <div id="preloder">
        <div class="loader"></div>
    </div>

    <!-- Header Section Begin -->
    <?php
    include "includes/head.php"
    ?>
    <!-- Header Section End -->

    <style>
        .spinner-border {
            position: absolute;
            top: 50%;
            left: 50%;
            margin-top: -20px;
            margin-left: -20px;
        }
    </style>





    <!-- Hero Section Begin -->
    <section class="hero hero-normal">
        <div class="container">
            <div class="row">
                <div class="col-lg-3">
                    <?php
                    include "sections/categories.php"
                    ?>
                </div>
                <div class="col-lg-9">
                    <?php
                    include "sections/search.php";
                    ?>
                </div>
            </div>
        </div>
    </section>
    <!-- Hero Section End -->

    <!-- Breadcrumb Section Begin -->
    <section class="">
        <div class="container">
            <div class="row">
                <nav aria-label="breadcrumb">
                    <ol class="breadcrumb">
                        <li class="breadcrumb-item"><a style="color: black !important;" href="./index.php" onmouseover="this.style.color='#225d2d'" onmouseout="this.style.color='black'">Home</a></li>

                        <li class="breadcrumb-item"><a style="color:#1877F2 !important;" href="#"> <b>Update Address</b> </a></li>
                    </ol>
                </nav>
            </div>
        </div>
    </section>
    <!-- Breadcrumb Section End -->







    <section style="padding-bottom: 70px; padding-top:8px">
        <div class="container py-2 mb-4" style="background-color: #eee;">
            <div class="row justify-content-center align-items-center">
                <div class="col-12 col-md-12 col-lg-8">
                    <div class="card mb-4">
                        <div class="card-header py-3">
                            <h5 class="mb-0">Edit Address</h5>
                        </div>
                        <div class="card-body">


                            <div class="spinner-border" id="loader" role="status">
                                <span class="sr-only">Loading...</span>

                            </div>



                            <form id="addressForm">
                                <div class="row mb-4">

                                    <div class="col">
                                        <div class="form-outline">
                                            <input type="text" id="name" class="form-control" name="name" value="<?php echo $userdata['fullname']; ?>" required />
                                            <label class="form-label" for="name">Name</label>
                                        </div>
                                    </div>
                                    <div class="col">
                                        <div class="form-outline">
                                            <input type="text" id="email" class="form-control" name="email" value="<?php echo $userdata['email']; ?>" required />
                                            <label class="form-label" for="email">Email</label>
                                        </div>
                                    </div>

                                </div>

                                <div class="row mb-4">
                                    <div class="col">
                                        <div class="form-outline">
                                            <input type="text" id="mobile" class="form-control" name="mobile" value="<?php echo $userdata['cell']; ?>" required />
                                            <label class="form-label" for="mobile">Mobile</label>
                                        </div>
                                    </div>

                                    <div class="col">
                                        <div class="form-outline">

                                            <select class="form-control" id="regions" name="region" aria-label=".form-select-lg example" required>
                                                <option selected>Open this select menu</option>
                                                <option value="1">One</option>

                                            </select>
                                            <label class="form-label" for="region">Region</label>


                                        </div>
                                    </div>
                                </div>

                                <div class="row mb-4">
                                    <div class="col">
                                        <div class="form-outline">
                                            <input type="text" id="road" class="form-control" name="road" required />
                                            <label class="form-label" for="road">Road</label>
                                        </div>
                                    </div>

                                    <div class="col">
                                        <div class="form-outline">

                                            <input type="text" id="building" class="form-control" name="building" required />
                                            <label class="form-label" for="building">Building</label>
                                        </div>
                                    </div>
                                </div>

                                <div class="row mb-4">
                                    <div class="col">
                                        <div class="form-outline">
                                            <input type="text" id="floor" class="form-control" name="floor" required />
                                            <label class="form-label" for="floor">Floor</label>
                                        </div>
                                    </div>
                                    <div class="col">
                                        <div class="form-outline">
                                            <input type="text" id="houseNo" class="form-control" name="houseNo" required />
                                            <label class="form-label" for="houseNo">House No</label>
                                        </div>
                                    </div>


                                </div>


                                <div class="form-outline mb-4">
                                    <small>optional</small> <br>
                                    <textarea name="moreinfor" id="moreinfor" placeholder="more information..." cols="30" rows="4" required></textarea> <br>
                                    <label class="form-label" for="moreinfor">More Information</label>
                                </div>


                                <input type="hidden" name="usercell" value="<?php echo $mobileNumber; ?>">
                                <input type="hidden" name="userid" value="<?php echo $id; ?>">
                                <input type="hidden" name="default1" value="1">
                                <input type="hidden" name="id" id="address-id">


                        

                                <div class="d-flex justify-content-end">
                                    <button class="btn btn-lg btn-main mt-2" id="submitBtn" type="submit">UPDATE</button>
                                </div>



                            </form>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>

    <?php
    include "includes/footer.php"
    ?>

    <script>
        function disableButton() {

            // Disable the button
            var submitBtn = document.getElementById("submitBtn");
            submitBtn.disabled = true;
            // Change background color to gray
            submitBtn.classList.add('btn-load');
            // Change the button text
            submitBtn.innerHTML = 'Processing...';


        }

        function enableButton() {
            // enable the button
            var submitBtn = document.getElementById("submitBtn");
            submitBtn.disabled = false;
            // Change background color to green
            submitBtn.classList.remove('btn-load');
            submitBtn.classList.add('btn-main');
            // Change the button text
            submitBtn.innerHTML = 'UPDATE';
        }

        $(document).ready(function() {




            getRegions();

    


        });



        function fetchDataAndPopulateForm() {

            var branchid = <?php echo $_SESSION['user_data']['branchid'] ?>;
            var userid = <?php echo $_SESSION['user']['ID'] ?>;

            var formData = {
                branchid: branchid,
                userid: userid
            };

            // Make an AJAX request to getdefaultaddress.php
            $.ajax({
                url: "functions/getdefaultaddress.php",
                type: "POST",
                data: formData,
                dataType: "json",
                success: function(data) {
                    // Call the populateForm function with the received data
                    populateForm(data);
                },
                error: function(xhr, status, error) {
                    // Handle the AJAX error
                    console.error(xhr.responseText);
                }
            });
        }

        function populateForm(data) {
            // Check if the response is not null
            if (data !== null) {

                $("#name").val(data.name);
                $("#email").val(data.email);
                $("#mobile").val(data.mobile);
                $("#regions").val(data.region);
                $("#road").val(data.road);
                $("#building").val(data.building);
                $("#floor").val(data.floor);
                $("#houseNo").val(data.houseNo);
                $("#moreinfor").val(data.moreinfor);
                $("#address-id").val(data.id);

                $("#noaddress").hide();
                $("#createAddressBtn").prop("disabled", false);

                // Show the form
                $("#addressForm").show();

            } else {
                // Show the noaddress div and disable the button
                $("#noaddress").show();
                $("#createAddressBtn").prop("disabled", true);

                // Hide the form
                $("#addressForm").hide();
            }

            document.getElementById('loader').style.display = 'none';
        }

        function getRegions() {

            disableButton();

            var branchid = <?php echo json_encode($_SESSION['user_data']['branchid']); ?>;
            var formData = {
                branchid: branchid
            };


            $.ajax({
                type: 'POST',
                url: 'functions/fetchregions.php',
                data: formData,
                dataType: 'json',
                success: function(response) {

                    // Extract regions array from the response
                    var regions = response;

                    // Get the select element
                    var regionsSelect = $('#regions');

                    // Clear existing options
                    regionsSelect.empty();


                    // Loop through regions and add options
                    for (var i = 0; i < regions.length; i++) {
                        regionsSelect.append('<option value="' + regions[i].id + '">' + regions[i].street + '</option>');
                    }

                    fetchDataAndPopulateForm();

                },
                error: function() {
                    Swal.fire({
                        title: 'Error',
                        text: 'An error occurred while processing your request.Please try again',
                        icon: 'error',
                    }).then((result) => {
                        enableButton()

                    });
                },
                complete: function() {

                    enableButton();
                    updateAddress();
                }
            });


        }


        function updateAddress(){
            $('form').submit(function(event) {
                event.preventDefault();

                // Get form data
                var formData = $(this).serialize();

                //set the value of 'default1' to 1 if checked, or 0 if not checked
                // formData += '&default1=' + ($('#default1').is(':checked') ? 1 : 0);


                disableButton();

                // Make an AJAX request to the server
                $.ajax({
                    type: 'POST',
                    url: 'functions/update_address.php',
                    data: formData,
                    dataType: 'json',
                    success: function(response) {
                        // Show SweetAlert based on the response
                        if (response.success) {

                            Swal.fire({
                                title: 'success',
                                text: response.message,
                                icon: 'success',
                            }).then((result) => {
                                window.location.href = 'address.php';

                            });


                        } else {
                            Swal.fire({
                                title: 'Error',
                                text: response.message,
                                icon: 'error',
                            }).then((result) => {
                                enableButton()

                            });
                        }
                    },
                    error: function() {
                        Swal.fire({
                            title: 'Error',
                            text: 'An error occurred while processing your request.Please try again',
                            icon: 'error',
                        }).then((result) => {
                            enableButton()

                        });
                    }
                });


            });
          }
    </script>